/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/* light.c */

#include <gl.h>
#include <stdio.h>
#include "light.h"


float my_light[] = {
	LCOLOR, .9, .9, .9,
	POSITION,  0.0, .1, .1, 0.0,
	LMNULL
};



void make_lights(void)
{
    /* define material #1 */
	
    static float array[] = {
		EMISSION, 0.1, 0.1, 0.1,
		AMBIENT,  0.1, 0.1, 0.1,
		DIFFUSE,  0.3, 0.3, 0.8,
		SPECULAR,  0.0, 0.0, 0.9,
		SHININESS, 10.0,
		LMNULL
    };
	
    lmdef(DEFMATERIAL, 1, sizeof(array), array);
	
    /* initialize model and light */
    lmdef(DEFLIGHT,1,0,(float *)NULL);
    lmdef(DEFLIGHT,2,10,my_light);
    lmdef(DEFLMODEL,1,0,(float *)NULL);

    lmbind(LIGHT0, 1);
    lmbind(LIGHT1, 2);
    lmbind(LMODEL, 1);
}


